# 特性

1. **简单**：支持通过Web页面对作业进行CRUD操作，操作简单，一分钟上手；
0. **动态**：支持动态修改作业状态、启动/停止作业，以及终止运行中作业，即时生效；
0. **调度控制中心 HA**：调度控制中心基于Akka Cluster并设置集群角色：job-control，集群内可配置多个调度中心以满足高可用。
    - 在多个调度中心角色Node中，使用Singleton来控制所有作业，当Singleton所在Node挂点后可自动在其它调度中心角色所在Node上恢复。
0. **执行器Agent HA**：执行器Agent基于Akka Cluster并设置集群角色：job-agent，可保证作业执行HA；
0. **自动注册**：新加入节点将根据设置的集群角色自己注册；
0. **弹性扩容缩容**：一旦有新执行器机器上线或者下线，下次调度时将会重新分配作业；
0. **路由策略**：执行器集群部署时提供丰富的路由策略，包括：第一个、最后一个、轮询、随机、一致性HASH、最不经常使用、最近最久未使用、故障转移、忙碌转移等；
0. **故障转移**：作业路由策略选择"故障转移"情况下，如果执行器集群中某一台机器故障，将会自动Failover切换到一台正常的执行器发送调度请求。
0. **阻塞处理策略**：调度过于密集执行器来不及处理时的处理策略，策略包括：单机串行（默认）、丢弃后续调度、覆盖之前调度；
0. **作业超时控制**：支持自定义作业超时时间，作业运行超时将会主动中断作业；
0. **作业失败重试**：支持自定义作业失败重试次数，当作业失败时将会按照预设的失败重试次数主动进行重试；其中分片作业支持分片粒度的失败重试；
0. **作业失败告警**：默认提供邮件方式失败告警，同时预留扩展接口，可方面的扩展短信、钉钉等告警方式；
0. 分片广播作业：执行器集群部署时，作业路由策略选择"分片广播"情况下，一次作业调度将会广播触发集群中所有执行器执行一次作业，可根据分片参数开发分片作业；
0. 动态分片：分片广播作业以执行器为维度进行分片，支持动态扩容执行器集群从而动态增加分片数量，协同进行业务处理；在进行大数据量业务操作时可显著提升作业处理能力和速度。
0. 事件触发：除了"Cron方式"和"作业依赖方式"触发作业执行之外，支持基于事件的触发作业方式。调度中心提供触发作业单次执行的API服务，可根据业务事件灵活触发。
0. 作业进度监控：支持实时监控作业进度；
0. Rolling实时日志：支持在线查看调度结果，并且支持以Rolling方式实时查看执行器输出的完整的执行日志；
0. Web IDE：提供Web IDE，支持在线开发作业逻辑代码，动态发布，实时编译生效，省略部署上线的过程。支持30个版本的历史版本回溯。
0. 脚本作业：支持以GLUE模式开发和运行脚本作业，包括Shell、Python、NodeJS等类型脚本;
0. 命令行作业：原生提供通用命令行作业Handler（Bean作业，"CommandJobHandler"）；业务方只需要提供命令行即可；
0. 作业依赖：支持配置子作业依赖，当父作业执行结束且执行成功后将会主动触发一次子作业的执行, 多个子作业用逗号分隔；
0. 一致性：“调度中心”通过DB锁保证集群分布式调度的一致性, 一次作业调度只会触发一次执行；
0. 自定义作业参数：支持在线配置调度作业入参，即时生效；
0. 调度线程池：调度系统多线程触发调度运行，确保调度精确执行，不被堵塞；
0. 数据加密：调度中心和执行器之间的通讯进行数据加密，提升调度信息安全性；
0. 邮件报警：作业失败时支持邮件报警，支持配置多邮件地址群发报警邮件；
0. 推送maven中央仓库: 将会把最新稳定版推送到maven中央仓库, 方便用户接入和使用;
0. 运行报表：支持实时查看运行数据，如作业数量、调度次数、执行器数量等；以及调度报表，如调度日期分布图，调度成功分布图等；
0. 全异步：作业调度流程全异步化设计实现，如异步调度、异步运行、异步回调等，有效对密集调度进行流量削峰，理论上支持任意时长作业的运行；
0. 跨平台：原生提供通用HTTP作业Handler（Bean作业，"HttpJobHandler"）；业务方只需要提供HTTP链接即可，不限制语言、平台；
0. 国际化：调度中心支持国际化设置，提供中文、英文两种可选语言，默认为中文；
0. 容器化：提供官方docker镜像，并实时更新推送dockerhub，进一步实现产品开箱即用；
