# 白皮书

工欲善其事，必先利其器

## 产品概述

尽管“数据是资产”概念已经广为人知，但“如何管理数据资产”仍然缺少成熟理论以及工具手段。

### 什么是数据资产？

数据资产是企业及组织拥有或控制，能带来未来经济利益的数据资源：报表、文件、数据库、接口、权限、视图……

**存在什么问题？**

1. 定义不统一：错误判断
2. 分配不透明：数据资产错配
3. 数据源不规范：导致无效数据加工
4. 加工流程混乱：人力、物力浪费
5. 数据不开放：企业数据合作受限
6. 处理缓慢：导致低效决策
7. 分布杂乱：数据资产闲置
8. 评估手段缺失：数所资产价值大打折扣

治理无力、应用低效、运营缺失

数据资产管理是企业或组织采取的各种管理活动，用以保证数据资产的安全完整，合理配置和有效利用，从而提高带来的经济效益，保障和促进各项事业发展。该领域是大数据时代企业布局竞争的核心，也是目前市场空白。

### 数据资产管理包括哪些核心内容？

**数据资产管理**

让企业数据更加准确、一致、完整、安全、降低IT成本。

**数据资产应用**

使得企业数据的使用过程更为人性、快捷、智能，从而提升管理决策水平。

**数据资产运营**

支持企业数据资产的分发、开放、交易等数据嫁接的实现，从而促进数据资产的价值实现。

### 建立一体化全流程的数据资产管理体系

数据资产管理体系核心在于有效解决对数据资产进行管理的实践性问题，既帮助企业合理评估、规范和治理企业信息资产，又可以挖掘和发挥数据资产价值并促进持续增值，并符合大数据的跨行业合作趋势。

![白皮书-一体化全流程的数据资产管理体系](imgs/白皮书-一体化全流程的数据资产管理体系.svg)

### 海量数据资产平台（MassData）：数据资产管理的专业管家

MassData作为数据资产管理平台，涵盖了采集、加工、使用、评估、优化、下线等数据资产的全生命周期管理，并基于全面数据治理能力，进一步提供专业化的数据资产“管家”服务，包括资产规划、运营管理、开放管理，以及面向企业客户和个人客户的不同类型数据资产应用，从而为大数据时代的数据资产管理和增值发展提供全面支持。

![白皮书-海量数据资产平台（MassData）](imgs/白皮书-海量数据资产平台（MassData）.svg)

### MassData将立足数据资产管理领域，服务于全行业和全客户

![白皮书-服务于全行业和全客户](imgs/白皮书-服务于全行业和全客户.svg)

### MassData能给企业内与数据资产相关的不同角色人员带来的价值

- **企业管理者**
    能够合理评估、规范和管理企业信息资产，在有效IT投资和降低管理成本的同时，挖掘和发挥数据资产价值并增值。
- **数据运营人员**
    支持多种数据使用模式，并提供更为丰富、安全的数据运营管理手段，有助于企业间进行更广泛的数据合作并由此创造价值。
- **业务运营人员**
    能够快速、高效的提供体验良好的数据展现手段，通过确保了数据资产质量，从而有助于做出更加准确的业务举措。
- **IT建设部门**
    能够规范数据处理过程、保障数据资产质量、提升IT系统建设效率、快速支撑业务部门运营需要，从而激发创新、体现价值。

### MassData不仅是技术工具、也是重要的运营管理手段！

- **良好界面体验**
    全Web段的在线操作，提供了丰富的可视化组件，能够优秀的帮助信息展现、问题定位和决策支持。
- **支持第三方应用集成**
- **使能数据开放**
    支持多租户管理、数据开放平台、数据合作加工模式等数据交互模式，并能够很好地保证数据使用过程中的隐私安全
- **完善规范标准**
    一整套管理办法和信息体系
- **一站式管理**
    * 面向业务人员提供快速取数、自助分析、门户定制等功能;
    * 面向技术人员提供可视化运维、自动化处理等工具;
    * 面向管理人员提供各种评估告警以及决策支持手段
- **智能化过程控制**
    能够根据数据资产实际使用过程进行智能化分析，并动态调整管理过程中的规则参数

## 功能架构



## 部署实施
